From 1ade67eed632a5be24011f75ce569b3707dbb74d Mon Sep 17 00:00:00 2001
From: Shugo Maeda <shugo@ruby-lang.org>
Date: Mon, 22 Nov 2010 15:56:50 +0900
Subject: [PATCH 49/51] Module#refine returns an anonymous module.

---
 eval.c                       |    2 +-
 test/ruby/test_refinement.rb |   11 +++++++++++
 2 files changed, 12 insertions(+), 1 deletions(-)

diff --git a/eval.c b/eval.c
index 4c4b0c1..1190a99 100644
--- a/eval.c
+++ b/eval.c
@@ -999,7 +999,7 @@ rb_mod_refine(VALUE module, VALUE klass)
 			       refinement_module_method_added, 1);
     rb_overlay_module(cref, klass, mod);
     rb_mod_module_eval(0, NULL, mod);
-    return Qnil;
+    return mod;
 }
 
 void
diff --git a/test/ruby/test_refinement.rb b/test/ruby/test_refinement.rb
index 8b86d4e..8161449 100644
--- a/test/ruby/test_refinement.rb
+++ b/test/ruby/test_refinement.rb
@@ -175,4 +175,15 @@ class TestRefinement < Test::Unit::TestCase
     assert_equal(Rational(1, 2), m.module_eval { 1 / 2 })
     assert_equal(0, 1 / 2)
   end
+
+  def test_return_value_of_refine
+    mod = nil
+    result = nil
+    m = Module.new {
+      result = refine Object do
+        mod = self
+      end
+    }
+    assert_equal mod, result
+  end
 end
-- 
1.7.0.4

